<?php
#-----------------------------------------------------#
#          ********* ROTORCMS *********               #
#             Made by   :  VANTUZ                     #
#               E-mail  :  visavi.net@mail.ru         #
#                 Site  :  http://pizdec.ru           #
#             WAP-Site  :  http://visavi.net          #
#                  ICQ  :  36-44-66                   #
#  Вы не имеете право вносить изменения в код скрипта #
#        для его дальнейшего распространения          #
#-----------------------------------------------------#	
require_once ('../includes/start.php');
require_once ('../includes/functions.php');
require_once ('../includes/header.php');
include_once ('../themes/' . $config['themes'] . '/index.php');

if (isset($_GET['act'])) {
  $act = check($_GET['act']);
} else {
  $act = 'index';
} 
if (isset($_GET['fid'])) {
  $fid = abs(intval($_GET['fid']));
} else {
  $fid = 0;
} 
if (isset($_GET['tid'])) {
  $tid = abs(intval($_GET['tid']));
} else {
  $tid = 0;
} 
if (isset($_GET['start'])) {
  $start = abs(intval($_GET['start']));
} else {
  $start = 0;
} 

if (is_admin(array(101, 102, 103, 105))) {
  show_title('menu.png', 'Управление форумом');
  $config['newtitle'] = 'Управление форумом';

  switch ($act): 
  # ###########################################################################################
  # #                                    Главная страница                                    ##
  # ###########################################################################################
  case "index":

    $queryforum = DB :: $dbh -> query("SELECT * FROM forums ORDER BY forums_order ASC;");
    $forums = $queryforum -> fetchAll();

    if (count($forums) > 0) {
      $output = array();

      foreach ($forums as $row) {
        $id = $row['forums_id'];
        $fp = $row['forums_parent'];
        $output[$fp][$id] = $row;
      } 

      echo '<a href="#down"><img src="../images/img/downs.gif" alt="Вниз" /></a> ';
      echo '<a href="../forum/index.php?' . SID . '">Обзор форума</a><hr />';

      foreach($output[0] as $key => $data) {
        echo '<div class="b"><img src="../images/img/forums.gif" alt="image" /> ';
        echo '<b>' . $data['forums_order'] . '. <a href="forum.php?act=forum&amp;fid=' . $data['forums_id'] . '&amp;' . SID . '">' . $data['forums_title'] . '</a></b> (' . $data['forums_topics'] . '/' . $data['forums_posts'] . ')<br />';

        if (is_admin(array(101))) {
          echo '<a href="forum.php?act=editforum&amp;fid=' . $data['forums_id'] . '&amp;' . SID . '">Редактировать</a> / ';
          echo '<a href="forum.php?act=prodelforum&amp;fid=' . $data['forums_id'] . '&amp;' . SID . '">Удалить</a>';
        } 

        echo '</div><div>'; 
        // ----------------------------------------------------//
        if (isset($output[$key])) {
          foreach($output[$key] as $datasub) {
            echo '<img src="../images/img/topics-small.gif" alt="image" /> ';
            echo '<b>' . $datasub['forums_order'] . '. <a href="forum.php?act=forum&amp;fid=' . $datasub['forums_id'] . '&amp;' . SID . '">' . $datasub['forums_title'] . '</a></b>  (' . $datasub['forums_topics'] . '/' . $datasub['forums_posts'] . ') ';
            if (is_admin(array(101))) {
              echo '(<a href="forum.php?act=editforum&amp;fid=' . $datasub['forums_id'] . '&amp;' . SID . '">Редактировать</a> / ';
              echo '<a href="forum.php?act=prodelforum&amp;fid=' . $datasub['forums_id'] . '&amp;' . SID . '">Удалить</a>)';
            } 
            echo '<br />';
          } 
        } 
        // ----------------------------------------------------//
        if ($data['forums_last_id'] > 0) {
          echo 'Тема: <a href="forum.php?act=topic&amp;tid=' . $data['forums_last_id'] . '&amp;' . SID . '">' . $data['forums_last_themes'] . '</a><br />';
          echo 'Сообщение: ' . nickname($data['forums_last_user']) . ' (' . date_fixed($data['forums_last_time']) . ')';
        } else {
          echo 'Темы еще не созданы!';
        } 
        echo '</div>';
      } 
    } else {
      show_error('Разделы форума еще не созданы!');
    } 

    if (is_admin(array(101))) {
      echo '<hr /><form action="forum.php?act=addforum&amp;uid=' . $_SESSION['token'] . '&amp;' . SID . '" method="post">';
      echo 'Заголовок:<br />';
      echo '<input type="text" name="title" maxlength="50" />';
      echo '<input type="submit" value="Создать раздел" /></form><hr />';

      echo '<img src="../images/img/reload.gif" alt="image" /> <a href="forum.php?act=restatement&amp;uid=' . $_SESSION['token'] . '&amp;' . SID . '">Пересчитать</a><br />';
    } 

    break; 
  # ###########################################################################################
  # #                                    Пересчет счетчиков                                  ##
  # ###########################################################################################
  case "restatement":

    $uid = check($_GET['uid']);

    if (is_admin(array(101))) {
      if ($uid == $_SESSION['token']) {
        DB :: $dbh -> query("UPDATE forums SET forums_topics=(SELECT count(*) FROM topics WHERE forums.forums_id=topics.topics_forums_id);");
        DB :: $dbh -> query("UPDATE forums SET forums_posts=(SELECT count(*) FROM posts WHERE forums.forums_id=posts.posts_forums_id);");
        DB :: $dbh -> query("UPDATE topics SET topics_posts=(SELECT count(*) FROM posts WHERE topics.topics_id=posts.posts_topics_id);");

        $_SESSION['note'] = 'Все данные успешно пересчитаны!';
        header ("Location: forum.php?" . SID);
        exit;
      } else {
        show_error('Ошибка! Неверный идентификатор сессии, повторите действие!');
      } 
    } else {
      show_error('Ошибка! Пересчитывать сообщения могут только суперадмины!');
    } 

    echo '<img src="../images/img/back.gif" alt="image" /> <a href="forum.php?' . SID . '">Вернуться</a><br />';
    break; 
  # ###########################################################################################
  # #                                    Добавление разделов                                 ##
  # ###########################################################################################
  case "addforum":

    $uid = check($_GET['uid']);
    $title = check($_POST['title']);

    if (is_admin(array(101))) {
      if ($uid == $_SESSION['token']) {
        if (utf_strlen($title) >= 3 && utf_strlen($title) < 50) {
          $maxorder = DB :: $dbh -> querySingle("SELECT IFNULL(MAX(`forums_order`),0)+1 FROM `forums`;");
          DB :: $dbh -> query("INSERT INTO `forums` (`forums_order`, `forums_title`) VALUES (?, ?);", array($maxorder, $title));

          $_SESSION['note'] = 'Новый раздел успешно добавлен!';
          header ("Location: forum.php?" . SID);
          exit;
        } else {
          show_error('Ошибка! Слишком длинное или короткое название раздела!');
        } 
      } else {
        show_error('Ошибка! Неверный идентификатор сессии, повторите действие!');
      } 
    } else {
      show_error('Ошибка! Добавлять разделы могут только суперадмины!');
    } 

    echo '<img src="../images/img/back.gif" alt="image" /> <a href="forum.php?' . SID . '">Вернуться</a><br />';
    break; 
  # ###########################################################################################
  # #                          Подготовка к редактированию разделов                          ##
  # ###########################################################################################
  case "editforum":

    if (is_admin(array(101))) {
      $queryforum = DB :: $dbh -> query("SELECT * FROM `forums` WHERE `forums_id`=? LIMIT 1;", array($fid));
      $forums = $queryforum -> fetch();

      if (!empty($forums)) {
        echo '<b><big>Редактирование</big></b><br /><br />';

        echo '<div class="form" id="form">';
        echo '<form action="forum.php?act=addeditforum&amp;fid=' . $fid . '&amp;uid=' . $_SESSION['token'] . '&amp;' . SID . '" method="post">';
        echo 'Раздел: <br />';
        echo '<input type="text" name="title" maxlength="50" value="' . $forums['forums_title'] . '" /><br />';

        $query = DB :: $dbh -> query("SELECT forums_id, forums_title, forums_parent FROM forums WHERE forums_parent=0 ORDER BY forums_order ASC;");
        $section = $query -> fetchAll();

        echo 'Родительский форум:<br />';
        echo '<select name="parent">';
        echo '<option value="0">Основной форум</option>';

        foreach ($section as $data) {
          if ($fid != $data['forums_id']) {
            $selected = ($forums['forums_parent'] == $data['forums_id']) ? ' selected="selected"' : '';
            echo '<option value="' . $data['forums_id'] . '"' . $selected . '>' . $data['forums_title'] . '</option>';
          } 
        } 
        echo '</select><br />';

        echo 'Положение: <br />';
        echo '<input type="text" name="order" maxlength="2" value="' . $forums['forums_order'] . '" /><br />';

        echo '<input type="submit" value="Изменить" /></form></div><br />';
      } else {
        show_error('Ошибка! Данного раздела не существует!');
      } 
    } else {
      show_error('Ошибка! Изменять разделы могут только суперадмины!');
    } 

    echo '<img src="../images/img/back.gif" alt="image" /> <a href="forum.php?' . SID . '">Вернуться</a><br />';
    break; 
  # ###########################################################################################
  # #                                 Редактирование разделов                                ##
  # ###########################################################################################
  case "addeditforum":

    $uid = check($_GET['uid']);
    $title = check($_POST['title']);
    $parent = abs(intval($_POST['parent']));
    $order = abs(intval($_POST['order']));

    if (is_admin(array(101))) {
      if ($uid == $_SESSION['token']) {
        if (utf_strlen($title) >= 3 && utf_strlen($title) < 50) {
          if ($fid != $parent) {
            $queryforum = DB :: $dbh -> query("SELECT forums_id FROM forums WHERE forums_parent=? LIMIT 1;", array($fid));
            $forums = $queryforum -> fetch();

            if (empty($forums) || $parent == 0) {
              DB :: $dbh -> query("UPDATE forums SET forums_order=?, forums_parent=?, forums_title=? WHERE forums_id=?;", array($order, $parent, $title, $fid));

              $_SESSION['note'] = 'Раздел успешно отредактирован!';
              header ("Location: forum.php?" . SID);
              exit;
            } else {
              show_error('Ошибка! Данный раздел имеет подфорумы!');
            } 
          } else {
            show_error('Ошибка! Недопустимый выбор родительского форума!');
          } 
        } else {
          show_error('Ошибка! Слишком длинное или короткое название раздела!');
        } 
      } else {
        show_error('Ошибка! Неверный идентификатор сессии, повторите действие!');
      } 
    } else {
      show_error('Ошибка! Изменять разделы могут только суперадмины!');
    } 

    echo '<img src="../images/img/reload.gif" alt="image" /> <a href="forum.php?act=editforum&amp;fid=' . $fid . '&amp;' . SID . '">Вернуться</a><br />';
    echo '<img src="../images/img/back.gif" alt="image" /> <a href="forum.php?' . SID . '">В Форум</a><br />';
    break;
  # ###########################################################################################
  # #                                  Подтвержение удаления                                 ##
  # ###########################################################################################
  case "prodelforum":

    if (is_admin(array(101))) {
      $queryforum = DB :: $dbh -> query("SELECT `f1`.*, count(`f2`.`forums_id`) AS `subcnt` FROM `forums` `f1` LEFT JOIN `forums` `f2` ON `f2`.`forums_parent` = `f1`.`forums_id` WHERE `f1`.`forums_id`=? LIMIT 1;", array($fid));
      $forums = $queryforum -> fetch();

      if (!empty($forums['forums_id'])) {
        if (empty($forums['subcnt'])) {
          echo 'Вы уверены что хотите удалить раздел <b>' . $forums['forums_title'] . '</b> в форуме?<br />';
          echo '<img src="../images/img/error.gif" alt="image" /> <b><a href="forum.php?act=delforum&amp;fid=' . $fid . '&amp;uid=' . $_SESSION['token'] . '&amp;' . SID . '">Да, уверен!</a></b><br /><br />';
        } else {
          show_error('Ошибка! Данный раздел имеет подфорумы!');
        } 
      } else {
        show_error('Ошибка! Данного раздела не существует!');
      } 
    } else {
      show_error('Ошибка! Удалять разделы могут только суперадмины!');
    } 

    echo '<img src="../images/img/back.gif" alt="image" /> <a href="forum.php?' . SID . '">Вернуться</a><br />';
    break;
  # ###########################################################################################
  # #                                    Подтвержение удаления                               ##
  # ###########################################################################################
  case "delforum":

    $uid = check($_GET['uid']);

    if (is_admin(array(101))) {
      if ($uid == $_SESSION['token']) {
        $queryforum = DB :: $dbh -> query("SELECT `f1`.*, count(`f2`.`forums_id`) AS `subcnt` FROM `forums` `f1` LEFT JOIN `forums` `f2` ON `f2`.`forums_parent` = `f1`.`forums_id` WHERE `f1`.`forums_id`=? LIMIT 1;", array($fid));
        $forums = $queryforum -> fetch();

        if (!empty($forums['forums_id'])) {
          if (empty($forums['subcnt'])) {
            DB :: $dbh -> query("DELETE FROM `posts` WHERE `posts_forums_id`=?;", array($fid));
            DB :: $dbh -> query("DELETE FROM `topics` WHERE `topics_forums_id`=?;", array($fid));
            DB :: $dbh -> query("DELETE FROM `forums` WHERE `forums_id`=?;", array($fid));

            $_SESSION['note'] = 'Раздел успешно удален!';
            header ("Location: forum.php?" . SID);
            exit;
          } else {
            show_error('Ошибка! Данный раздел имеет подфорумы!');
          } 
        } else {
          show_error('Ошибка! Данного раздела не существует!');
        } 
      } else {
        show_error('Ошибка! Неверный идентификатор сессии, повторите действие!');
      } 
    } else {
      show_error('Ошибка! Удалять разделы могут только суперадмины!');
    } 

    echo '<img src="../images/img/back.gif" alt="image" /> <a href="forum.php?' . SID . '">Вернуться</a><br />';
    break; 
  # ###########################################################################################
  # #                                    Просмотр тем в разделе                              ##
  # ###########################################################################################
  case "forum":

    $queryforum = DB :: $dbh -> query("SELECT * FROM forums WHERE forums_id=? LIMIT 1;", array($fid));
    $forums = $queryforum -> fetch();

    if ($forums > 0) {
      echo '<a href="#down"><img src="../images/img/downs.gif" alt="Вниз" /></a> ';
      echo '<a href="forum.php?' . SID . '">Форум</a> / ';
      echo '<a href="../forum/forum.php?fid=' . $fid . '&amp;start=' . $start . '&amp;' . SID . '">Обзор раздела</a><br /><br />';

      echo '<img src="../images/img/themes.gif" alt="image" /> <b>' . $forums['forums_title'] . '</b><hr />';

      $total = DB :: $dbh -> querySingle("SELECT count(*) FROM topics WHERE topics_forums_id=?;", array($fid));

      if ($total > 0) {
        if ($start >= $total) {
          $start = 0;
        } 

        $querytopic = DB :: $dbh -> query("SELECT * FROM topics WHERE topics_forums_id=? ORDER BY topics_locked DESC, topics_last_time DESC LIMIT " . $start . ", " . $config['forumtem'] . ";", array($fid));

        echo '<form action="forum.php?act=deltopics&amp;fid=' . $fid . '&amp;start=' . $start . '&amp;uid=' . $_SESSION['token'] . '&amp;' . SID . '" method="post">';

        while ($data = $querytopic -> fetch()) {
          echo '<div class="b">';

          if ($data['topics_locked'] == 1) {
            echo '<img src="../images/img/lock.gif" alt="image" /> ';
          } elseif ($data['topics_closed'] == 1) {
            echo '<img src="../images/img/closed.gif" alt="image" /> ';
          } else {
            echo '<img src="../images/img/topics.gif" alt="image" /> ';
          } 

          echo '<b><a href="forum.php?act=topic&amp;tid=' . $data['topics_id'] . '&amp;' . SID . '">' . $data['topics_title'] . '</a></b> (' . $data['topics_posts'] . ')<br />';

          echo '<input type="checkbox" name="del[]" value="' . $data['topics_id'] . '" /> ';

          echo '<a href="forum.php?act=edittopic&amp;tid=' . $data['topics_id'] . '&amp;start=' . $start . '&amp;' . SID . '">Редактировать</a> / ';
          echo '<a href="forum.php?act=movetopic&amp;tid=' . $data['topics_id'] . '&amp;start=' . $start . '&amp;' . SID . '">Переместить</a></div>';

          echo '<div>Страницы: ';
          forum_navigation('forum.php?act=topic&tid=' . $data['topics_id'] . '&amp;', $config['forumpost'], $data['topics_posts']);
          echo 'Сообщение: ' . nickname($data['topics_last_user']) . ' (' . date_fixed($data['topics_last_time']) . ')</div>';
        } 

        echo '<br /><input type="submit" value="Удалить выбранное" /></form>';

        page_strnavigation('forum.php?act=forum&amp;fid=' . $fid . '&amp;', $config['forumtem'], $start, $total);
      } else {
        show_error('В данном форуме еще нет тем!');
      } 
    } else {
      show_error('Ошибка! Данного раздела не существует!');
    } 

    echo '<img src="../images/img/reload.gif" alt="image" /> <a href="forum.php?' . SID . '">К форумам</a><br />';
    break; 
  # ###########################################################################################
  # #                            Подготовка к редактированию темы                            ##
  # ###########################################################################################
  case "edittopic":

    $querytopic = DB :: $dbh -> query("SELECT topics.*, forums.forums_id FROM topics LEFT JOIN forums ON topics.topics_forums_id=forums.forums_id WHERE topics_id=? LIMIT 1;", array($tid));
    $topics = $querytopic -> fetch();

    if (!empty($topics)) {
      echo '<b><big>Редактирование</big></b><br /><br />';

      echo '<div class="form" id="form">';
      echo '<form action="forum.php?act=addedittopic&amp;fid=' . $topics['forums_id'] . '&amp;tid=' . $tid . '&amp;start=' . $start . '&amp;uid=' . $_SESSION['token'] . '&amp;' . SID . '" method="post">';
      echo 'Тема: <br />';
      echo '<input type="text" name="title" size="50" maxlength="50" value="' . $topics['topics_title'] . '" /><br />';
      echo 'Кураторы темы: <br />';
      echo '<input type="text" name="mod" size="50" maxlength="100" value="' . $topics['topics_mod'] . '" /><br /><br />';

      echo 'Закрепить тему: ';
      $checked = ($topics['topics_locked'] == 1) ? ' checked="checked"' : '';
      echo '<input name="locked" type="checkbox" value="1"' . $checked . ' /><br />';

      echo 'Закрыть тему: ';
      $checked = ($topics['topics_closed'] == 1) ? ' checked="checked"' : '';
      echo '<input name="closed" type="checkbox" value="1"' . $checked . ' /><br />';

      echo '<br /><input type="submit" value="Изменить" /></form></div><br />';
    } else {
      show_error('Ошибка! Данной темы не существует!');
    } 

    echo '<img src="../images/img/back.gif" alt="image" /> <a href="forum.php?act=forum&amp;fid=' . $topics['forums_id'] . '&amp;start=' . $start . '&amp;' . SID . '">Вернуться</a><br />';
    break; 
  # ###########################################################################################
  # #                                     Редактирование темы                                ##
  # ###########################################################################################
  case "addedittopic":

    $uid = check($_GET['uid']);
    $title = check($_POST['title']);
    $mod = check($_POST['mod']);
    $locked = (empty($_POST['locked'])) ? 0 : 1;
    $closed = (empty($_POST['closed'])) ? 0 : 1;

    if ($uid == $_SESSION['token']) {
      if (utf_strlen($title) >= 5 && utf_strlen($title) < 50) {
        DB :: $dbh -> query("UPDATE topics SET topics_title=?, topics_closed=?, topics_locked=?, topics_mod=? WHERE topics_id=?;", array($title, $closed, $locked, $mod, $tid));

        if ($locked == 1) {
          $start = 0;
        } 
        $_SESSION['note'] = 'Тема успешно отредактирована!';
        header ("Location: forum.php?act=forum&fid=$fid&start=$start&" . SID);
        exit;
      } else {
        show_error('Ошибка! Слишком длинное или короткое название темы!');
      } 
    } else {
      show_error('Ошибка! Неверный идентификатор сессии, повторите действие!');
    } 

    echo '<img src="../images/img/back.gif" alt="image" /> <a href="forum.php?act=edittopic&amp;tid=' . $tid . '&amp;start=' . $start . '&amp;' . SID . '">Вернуться</a><br />';
    echo '<img src="../images/img/reload.gif" alt="image" /> <a href="forum.php?act=forum&amp;fid=' . $fid . '&amp;start=' . $start . '&amp;' . SID . '">К темам</a><br />';
    break; 
  # ###########################################################################################
  # #                               Подготовка к перемещению темы                            ##
  # ###########################################################################################
  case "movetopic":

    $querytopic = DB :: $dbh -> query("SELECT * FROM topics WHERE topics_id=? LIMIT 1;", array($tid));
    $topics = $querytopic -> fetch();

    if (!empty($topics)) {
      echo '<img src="../images/img/topics.gif" alt="image" /> <b>' . $topics['topics_title'] . '</b> (Автор темы: ' . nickname($topics['topics_author']) . ')<br /><br />';

      $queryforum = DB :: $dbh -> query("SELECT forums_id, forums_parent, forums_title FROM forums ORDER BY forums_order ASC;");
      $forums = $queryforum -> fetchAll();

      if (count($forums) > 0) {
        $output = array();
        foreach ($forums as $row) {
          $i = $row['forums_id'];
          $p = $row['forums_parent'];
          $output[$p][$i] = $row;
        } 

        echo '<div class="form" id="form"><form action="forum.php?act=addmovetopic&amp;fid=' . $topics['topics_forums_id'] . '&amp;tid=' . $tid . '&amp;uid=' . $_SESSION['token'] . '&amp;' . SID . '" method="post">';

        echo 'Выберите раздел для перемещения:<br />';
        echo '<select name="section">';

        foreach ($output[0] as $key => $data) {
          if ($topics['topics_forums_id'] != $data['forums_id']) {
            echo '<option value="' . $data['forums_id'] . '">' . $data['forums_title'] . '</option>';
          } 

          if (isset($output[$key])) {
            foreach($output[$key] as $datasub) {
              if ($topics['topics_forums_id'] != $datasub['forums_id']) {
                echo '<option value="' . $datasub['forums_id'] . '">– ' . $datasub['forums_title'] . '</option>';
              } 
            } 
          } 
        } 

        echo '</select>';

        echo '<input type="submit" value="Переместить" /></form></div><br />';
      } else {
        show_error('Разделы форума еще не созданы!');
      } 
    } else {
      show_error('Ошибка! Данной темы не существует!');
    } 

    echo '<img src="../images/img/back.gif" alt="image" /> <a href="forum.php?act=forum&amp;fid=' . $topics['topics_forums_id'] . '&amp;start=' . $start . '&amp;' . SID . '">Вернуться</a><br />';
    break; 
  # ###########################################################################################
  # #                                    Перемещение темы                                    ##
  # ###########################################################################################
  case "addmovetopic":

    $uid = check($_GET['uid']);
    $section = abs(intval($_POST['section']));

    if ($uid == $_SESSION['token']) {
      $queryforum = DB :: $dbh -> query("SELECT * FROM forums WHERE forums_id=? LIMIT 1;", array($section));
      $forums = $queryforum -> fetch();

      $querytopic = DB :: $dbh -> query("SELECT * FROM topics WHERE topics_id=? LIMIT 1;", array($tid));
      $topics = $querytopic -> fetch();

      if ($forums > 0) {
        $title = $topics['topics_title'] . ' (Перемещено)';
        $msg = 'Тема была перемещена в раздел [b]' . $forums['forums_title'] . '[/b] по адресу ' . $config['home'] . '/forum/topic.php?tid=' . $tid;

        DB :: $dbh -> query("INSERT INTO topics (topics_forums_id, topics_title, topics_author, topics_closed, topics_posts, topics_last_user, topics_last_time) VALUES (?, ?, ?, ?, ?, ?, ?);", array($topics['topics_forums_id'], $title, $topics['topics_author'], 1, 1, $log, SITETIME));

        $lastid = DB :: $dbh -> lastInsertId();

        DB :: $dbh -> query("INSERT INTO posts (posts_topics_id, posts_forums_id, posts_user, posts_text, posts_time, posts_ip, posts_brow) VALUES (?, ?, ?, ?, ?, ?, ?);", array($lastid, $topics['topics_forums_id'], $log, $msg, SITETIME, $ip, $brow)); 
        // Обновление номера раздела
        DB :: $dbh -> query("UPDATE topics SET topics_forums_id=? WHERE topics_id=?;", array($section, $tid));
        DB :: $dbh -> query("UPDATE posts SET posts_forums_id=? WHERE posts_topics_id=?;", array($section, $tid)); 
        // Обновление счетчиков
        DB :: $dbh -> query("UPDATE forums SET forums_topics=forums_topics+1, forums_posts=forums_posts+? WHERE forums_id=?", array($topics['topics_posts'], $section));
        DB :: $dbh -> query("UPDATE forums SET forums_posts=forums_posts+1-? WHERE forums_id=?", array($topics['topics_posts'], $topics['topics_forums_id'])); 
        // ------------------------------------------------------------//
        $oldtopic = DB :: $dbh -> query("SELECT * FROM topics WHERE topics_forums_id=? ORDER BY topics_last_time DESC LIMIT 1;", array($topics['topics_forums_id']));
        $oldlast = $oldtopic -> fetch();

        $newtopic = DB :: $dbh -> query("SELECT * FROM topics WHERE topics_forums_id=? ORDER BY topics_last_time DESC LIMIT 1;", array($section));
        $newlast = $newtopic -> fetch();

        DB :: $dbh -> query("UPDATE forums SET forums_last_id=?, forums_last_themes=?, forums_last_user=?, forums_last_time=? WHERE forums_id=?", array($oldlast['topics_id'], $oldlast['topics_title'], $oldlast['topics_last_user'], $oldlast['topics_last_time'], $oldlast['topics_forums_id']));

        DB :: $dbh -> query("UPDATE forums SET forums_last_id=?, forums_last_themes=?, forums_last_user=?, forums_last_time=? WHERE forums_id=?", array($newlast['topics_id'], $newlast['topics_title'], $newlast['topics_last_user'], $newlast['topics_last_time'], $newlast['topics_forums_id']));

        $_SESSION['note'] = 'Тема успешно перемещена!';
        header ("Location: forum.php?act=forum&fid=$section&" . SID);
        exit;
      } else {
        show_error('Ошибка! Выбранного раздела не существует!');
      } 
    } else {
      show_error('Ошибка! Неверный идентификатор сессии, повторите действие!');
    } 

    echo '<img src="../images/img/back.gif" alt="image" /> <a href="forum.php?act=movetopic&amp;tid=' . $tid . '&amp;' . SID . '">Вернуться</a><br />';
    echo '<img src="../images/img/reload.gif" alt="image" /> <a href="forum.php?act=forum&amp;fid=' . $fid . '&amp;' . SID . '">К темам</a><br />';
    break; 
  # ###########################################################################################
  # #                                     Удаление тем                                       ##
  # ###########################################################################################
  case "deltopics":

    $uid = check($_GET['uid']);
    if (isset($_POST['del'])) {
      $del = intar($_POST['del']);
    } elseif (isset($_GET['del'])) {
      $del = array(abs(intval($_GET['del'])));
    } else {
      $del = 0;
    } 

    if ($uid == $_SESSION['token']) {
      if ($del > 0) {
        $del = implode(',', $del);

        $deltopics = DB :: $dbh -> exec("DELETE FROM topics WHERE topics_id IN (" . $del . ");");
        $delposts = DB :: $dbh -> exec("DELETE FROM posts WHERE posts_topics_id IN (" . $del . ");"); 
        // Обновление счетчиков
        DB :: $dbh -> query("UPDATE forums SET forums_topics=forums_topics-?, forums_posts=forums_posts-? WHERE forums_id=?", array($deltopics, $delposts, $fid)); 
        // ------------------------------------------------------------//
        $oldtopic = DB :: $dbh -> query("SELECT * FROM topics WHERE topics_forums_id=? ORDER BY topics_last_time DESC LIMIT 1;", array($fid));
        $oldlast = $oldtopic -> fetch();

        DB :: $dbh -> query("UPDATE forums SET forums_last_id=?, forums_last_themes=?, forums_last_user=?, forums_last_time=? WHERE forums_id=?", array($oldlast['topics_id'], $oldlast['topics_title'], $oldlast['topics_last_user'], $oldlast['topics_last_time'], $fid));

        $_SESSION['note'] = 'Выбранные темы успешно удалены!';
        header ("Location: forum.php?act=forum&fid=$fid&start=$start&" . SID);
        exit;
      } else {
        show_error('Ошибка! Отсутствуют выбранные темы форума!');
      } 
    } else {
      show_error('Ошибка! Неверный идентификатор сессии, повторите действие!');
    } 

    echo '<img src="../images/img/back.gif" alt="image" /> <a href="forum.php?act=forum&amp;fid=' . $fid . '&amp;start=' . $start . '&amp;' . SID . '">Вернуться</a><br />';
    break; 
  # ###########################################################################################
  # #                                  Закрытие - Закрепление темы                           ##
  # ###########################################################################################
  case "acttopic":

    $uid = check($_GET['uid']);
    $do = check($_GET['do']);

    if ($uid == $_SESSION['token']) {
      $querytopic = DB :: $dbh -> query("SELECT * FROM topics WHERE topics_id=? LIMIT 1;", array($tid));
      $topics = $querytopic -> fetch();

      if (!empty($topics)) {
        switch ($do):
        case "closed":
          DB :: $dbh -> query("UPDATE topics SET topics_closed=? WHERE topics_id=?;", array(1, $tid));
          $_SESSION['note'] = 'Тема успешно закрыта!';
          header ("Location: forum.php?act=topic&tid=$tid&start=$start&" . SID);
          exit;
          break;

        case "open":
          DB :: $dbh -> query("UPDATE topics SET topics_closed=? WHERE topics_id=?;", array(0, $tid));
          $_SESSION['note'] = 'Тема успешно открыта!';
          header ("Location: forum.php?act=topic&tid=$tid&start=$start&" . SID);
          exit;
          break;

        case "locked":
          DB :: $dbh -> query("UPDATE topics SET topics_locked=? WHERE topics_id=?;", array(1, $tid));
          $_SESSION['note'] = 'Тема успешно закреплена!';
          header ("Location: forum.php?act=topic&tid=$tid&start=$start&" . SID);
          exit;
          break;

        case "unlocked":
          DB :: $dbh -> query("UPDATE topics SET topics_locked=? WHERE topics_id=?;", array(0, $tid));
          $_SESSION['note'] = 'Тема успешно откреплена!';
          header ("Location: forum.php?act=topic&tid=$tid&start=$start&" . SID);
          exit;
          break;

        default:
          show_error('Ошибка! Не выбрано действие для темы!');
          endswitch;
        } else {
        show_error('Ошибка! Данной темы не существует!');
      } 
    } else {
      show_error('Ошибка! Неверный идентификатор сессии, повторите действие!');
    } 

    echo '<img src="../images/img/reload.gif" alt="image" /> <a href="forum.php?' . SID . '">К форумам</a><br />';
    break; 
  # ###########################################################################################
  # #                                     Просмотр сообщений                                 ##
  # ###########################################################################################
  case "topic":

    $querytopic = DB :: $dbh -> query("SELECT topics.*, forums.forums_id, forums.forums_title FROM topics LEFT JOIN forums ON topics.topics_forums_id=forums.forums_id WHERE topics_id=? LIMIT 1;", array($tid));
    $topic = $querytopic -> fetch();

    if ($topic > 0) {
      echo '<a href="#down"><img src="../images/img/downs.gif" alt="Вниз" /></a> ';
      echo '<a href="forum.php?' . SID . '">Форум</a> / ';
      echo '<a href="forum.php?act=forum&amp;fid=' . $topic['forums_id'] . '&amp;' . SID . '">' . $topic['forums_title'] . '</a> / ';
      echo '<a href="../forum/topic.php?tid=' . $tid . '&amp;start=' . $start . '&amp;' . SID . '">Обзор темы</a><br /><br />';

      echo '<img src="../images/img/themes.gif" alt="image" /> <b>' . $topic['topics_title'] . '</b>';

      if (!empty($topic['topics_mod'])) {
        $topics_mod = explode(',', $topic['topics_mod']);

        echo '<br />Кураторы темы: ';
        foreach ($topics_mod as $mkey => $mval) {
          if ($mkey == 0) {
            $comma = '';
          } else {
            $comma = ', ';
          } 
          echo $comma . nickname($mval);
        } 
      } 
      echo '<hr />';

      if (empty($topic['topics_closed'])) {
        echo '<a href="' . ADMINDIR . 'forum.php?act=acttopic&amp;do=closed&amp;tid=' . $tid . '&amp;start=' . $start . '&amp;uid=' . $_SESSION['token'] . '&amp;' . SID . '">Закрыть</a> / ';
      } else {
        echo '<a href="' . ADMINDIR . 'forum.php?act=acttopic&amp;do=open&amp;tid=' . $tid . '&amp;start=' . $start . '&amp;uid=' . $_SESSION['token'] . '&amp;' . SID . '">Открыть</a> / ';
      } 

      if (empty($topic['topics_locked'])) {
        echo '<a href="' . ADMINDIR . 'forum.php?act=acttopic&amp;do=locked&amp;tid=' . $tid . '&amp;start=' . $start . '&amp;uid=' . $_SESSION['token'] . '&amp;' . SID . '">Закрепить</a> / ';
      } else {
        echo '<a href="' . ADMINDIR . 'forum.php?act=acttopic&amp;do=unlocked&amp;tid=' . $tid . '&amp;start=' . $start . '&amp;uid=' . $_SESSION['token'] . '&amp;' . SID . '">Открепить</a> / ';
      } 

      echo '<a href="' . ADMINDIR . 'forum.php?act=edittopic&amp;tid=' . $tid . '&amp;start=' . $start . '&amp;' . SID . '">Изменить</a> / ';
      echo '<a href="' . ADMINDIR . 'forum.php?act=movetopic&amp;tid=' . $tid . '&amp;' . SID . '">Переместить</a> / ';
      echo '<a href="' . ADMINDIR . 'forum.php?act=deltopics&amp;fid=' . $topic['forums_id'] . '&amp;del=' . $tid . '&amp;uid=' . $_SESSION['token'] . '&amp;' . SID . '" onclick="return confirm(\'Вы действительно хотите удалить данную тему?\')">Удалить</a>';

      $total = DB :: $dbh -> query("SELECT count(*) FROM posts WHERE posts_topics_id=?;", array($tid));
      $total = $total -> fetchColumn();

      if ($total > 0) {
        if ($start >= $total) {
          $start = 0;
        } 

        $querypost = DB :: $dbh -> query("SELECT * FROM posts WHERE posts_topics_id=? ORDER BY posts_time ASC LIMIT " . $start . ", " . $config['forumpost'] . ";", array($tid));

        echo '<form action="forum.php?act=delposts&amp;tid=' . $tid . '&amp;start=' . $start . '&amp;uid=' . $_SESSION['token'] . '&amp;' . SID . '" method="post">';

        $i = 0;
        while ($data = $querypost -> fetch()) {
          ++$i;

          echo '<div class="b">' . user_avatars($data['posts_user']);

          echo '<b>' . ($start + $i) . '. <a href="../pages/anketa.php?uz=' . $data['posts_user'] . '&amp;' . SID . '">' . nickname($data['posts_user']) . '</a></b> ' . user_title($data['posts_user']) . user_online($data['posts_user']) . ' ';
          echo '<small>(' . date_fixed($data['posts_time']) . ')</small><br />';

          echo '<input type="checkbox" name="del[]" value="' . $data['posts_id'] . '" /> ';
          echo '<a href="forum.php?act=editpost&amp;tid=' . $tid . '&amp;pid=' . $data['posts_id'] . '&amp;start=' . $start . '&amp;' . SID . '">Редактировать</a></div>';

          echo '<div>' . bb_code($data['posts_text']) . '<br />';

          if (!empty($data['posts_edit'])) {
            echo '<img src="../images/img/exclamation_small.gif" alt="image" /> <small>Отредактировано: ' . nickname($data['posts_edit']) . ' (' . date_fixed($data['posts_edit_time']) . ')</small><br />';
          } 

          echo '<span class="data">(' . $data['posts_brow'] . ', ' . $data['posts_ip'] . ')</span></div>';
        } 

        echo '<br /><input type="submit" value="Удалить выбранное" /></form>';

        page_strnavigation('forum.php?act=topic&amp;tid=' . $tid . '&amp;', $config['forumpost'], $start, $total);
      } else {
        show_error('Сообщений еще нет, будь первым!');
      } 

      if ($topic['topics_closed'] == 0) {
        echo '<div class="form" id="form">';
        echo '<form action="../forum/topic.php?act=add&amp;tid=' . $tid . '&amp;start=' . $start . '&amp;uid=' . $_SESSION['token'] . '&amp;' . SID . '" method="post">';
        echo 'Сообщение:<br />';
        echo '<textarea cols="25" rows="3" name="msg" id="msg"></textarea><br />';
        echo '<input type="submit" value="Написать" /></form></div><br />';
      } else {
        show_error('Данная тема закрыта для обсуждения!');
      } 
    } else {
      show_error('Ошибка! Данной темы не существует!');
    } 

    echo '<img src="../images/img/reload.gif" alt="image" /> <a href="forum.php?' . SID . '">К форумам</a><br />';
    break; 
  # ###########################################################################################
  # #                                    Удаление сообщений                                  ##
  # ###########################################################################################
  case "delposts":

    $uid = check($_GET['uid']);
    if (isset($_POST['del'])) {
      $del = intar($_POST['del']);
    } else {
      $del = 0;
    } 

    if ($uid == $_SESSION['token']) {
      if (!empty($del)) {
        $querytopic = DB :: $dbh -> query("SELECT * FROM topics WHERE topics_id=? LIMIT 1;", array($tid));
        $topics = $querytopic -> fetch();

        $del = implode(',', $del);

        $delposts = DB :: $dbh -> exec("DELETE FROM posts WHERE posts_id IN (" . $del . ") AND posts_topics_id=" . $tid . ";");
        DB :: $dbh -> query("UPDATE topics SET topics_posts=topics_posts-? WHERE topics_id=?", array($delposts, $tid));
        DB :: $dbh -> query("UPDATE forums SET forums_posts=forums_posts-? WHERE forums_id=?", array($delposts, $topics['topics_forums_id']));

        $_SESSION['note'] = 'Выбранные сообщения успешно удалены!';
        header ("Location: forum.php?act=topic&tid=$tid&start=$start&" . SID);
        exit;
      } else {
        show_error('Ошибка! Отсутствуют выбранные сообщения!');
      } 
    } else {
      show_error('Ошибка! Неверный идентификатор сессии, повторите действие!');
    } 

    echo '<img src="../images/img/back.gif" alt="image" /> <a href="forum.php?act=topic&amp;tid=' . $tid . '&amp;start=' . $start . '&amp;' . SID . '">Вернуться</a><br />';
    break; 
  # ###########################################################################################
  # #                                   Подготовка к редактированию                          ##
  # ###########################################################################################
  case "editpost":

    $pid = abs(intval($_GET['pid']));

    $querypost = DB :: $dbh -> query("SELECT * FROM posts WHERE posts_id=? LIMIT 1;", array($pid));
    $post = $querypost -> fetch();

    if ($post > 0) {
      $post['posts_text'] = nosmiles($post['posts_text']);
      $post['posts_text'] = str_replace('<br />', "\r\n", $post['posts_text']);

      echo '<img src="../images/img/edit.gif" alt="image" /> <b>' . nickname($post['posts_user']) . '</b> <small>(' . date_fixed($post['posts_time']) . ')</small><br /><br />';

      echo '<div class="form" id="form">';
      echo '<form action="forum.php?act=addeditpost&amp;tid=' . $post['posts_topics_id'] . '&amp;pid=' . $pid . '&amp;start=' . $start . '&amp;uid=' . $_SESSION['token'] . '&amp;' . SID . '" method="post">';
      echo 'Редактирование сообщения:<br />';
      echo '<textarea cols="25" rows="5" name="msg" id="msg">' . $post['posts_text'] . '</textarea><br />';
      echo '<input value="Редактировать" name="do" type="submit" /></form></div><br />';
    } else {
      show_error('Ошибка! Данного сообщения не существует!');
    } 

    echo '<img src="../images/img/back.gif" alt="image" /> <a href="forum.php?act=topic&amp;tid=' . $tid . '&amp;start=' . $start . '&amp;' . SID . '">Вернуться</a><br />';
    break; 
  # ###########################################################################################
  # #                                    Редактирование сообщения                            ##
  # ###########################################################################################
  case "addeditpost":

    $uid = check($_GET['uid']);
    $pid = abs(intval($_GET['pid']));
    $msg = check($_POST['msg']);

    if ($uid == $_SESSION['token']) {
      if (utf_strlen($msg) >= 5 && utf_strlen($msg) < 3000) {
        $querypost = DB :: $dbh -> query("SELECT * FROM posts WHERE posts_id=? LIMIT 1;", array($pid));
        $post = $querypost -> fetch();

        if ($post > 0) {
          $msg = no_br($msg);
          $msg = smiles($msg);

          DB :: $dbh -> query("UPDATE posts SET posts_text=?, posts_edit=?, posts_edit_time=? WHERE posts_id=?", array($msg, $log, SITETIME, $pid));

          $_SESSION['note'] = 'Сообщение успешно отредактировано!';
          header ("Location: forum.php?act=topic&tid=$tid&start=$start&" . SID);
          exit;
        } else {
          show_error('Ошибка! Данного сообщения не существует!');
        } 
      } else {
        show_error('Ошибка! Слишком длинное или короткое сообщение!');
      } 
    } else {
      show_error('Ошибка! Неверный идентификатор сессии, повторите действие!');
    } 

    echo '<img src="../images/img/back.gif" alt="image" /> <a href="forum.php?act=editpost&amp;tid=' . $tid . '&amp;pid=' . $pid . '&amp;start=' . $start . '&amp;' . SID . '">Вернуться</a><br />';
    break;

  default:
    header("location: forum.php?" . SID);
    exit;
    endswitch;

    echo '<img src="../images/img/panel.gif" alt="image" /> <a href="index.php?' . SID . '">В админку</a><br />';
    echo '<img src="../images/img/homepage.gif" alt="image" /> <a href="../index.php?' . SID . '">На главную</a>';
  } else {
  header ('Location: ' . BASEDIR . 'index.php?' . SID);
  exit;
} 

include_once ('../themes/' . $config['themes'] . '/foot.php');

?>